// Ulysse Version 0.8.6
// Commutateur de messages

/**
* @author Pierre Nugues
* @version 0.8.6
*/

import java.io.*;
import java.net.*;
import java.util.*;

public class Connex {

	public final static int DEFAULT_PORT = 2040;
	protected static int port;
	protected static String fichierInit = "c:\\docume~1\\pierre\\mydocu~1\\projets\\ulysse\\ulysse.ini"; // sur PC
                                                //"c:\\docume~1\\pierre\\mesdoc~1\\ulysse\\ulysse.ini"; //"c:\\windows\\bureau\\Ulysse\\ulysse.ini";
						//"/users/ens/nugues/public_html/ulysse/ulysse_unix.ini";
						//"c:\\windows\\bureau\\Ulysse\\ulysse.ini"; // sur PC
						// "/users/nugues/public_html/ulysse/ulysse_unix.ini";

	public static void main(String [] args) {
		ServerSocket serveur;
		
		if (args.length >= 1)
			port = Integer.parseInt(args[0]);
		else
			port = DEFAULT_PORT;
		if (args.length == 2)
			fichierInit = new String(args[1]);
		try {
			serveur = new ServerSocket(port);
			System.out.println("Serveur dmarr au port " + port);
		} catch(IOException e) {
			System.err.println("chec dans la cration de la socket serveur " + port + ":" + e);
			System.exit(1);
			return; // not reached
		}
		while (true) {
			try {
				Socket client = serveur.accept();
				new ConnexionServeur(client).start();
				System.out.println("Un client dmarr");
			} catch (IOException e) {}
		}
//			serveur.close();
	}
}

//Traite les connexions des clients au serveur et lance le Prolog
class ConnexionServeur extends Thread {
	Socket client;

	protected Process prologProcess;	// The language engine process -- a Prolog program
	
	protected BufferedReader inFromProlog;	// BufferedReader from Prolog
	protected PrintWriter outToProlog; 	// PrintWriter to Prolog
	protected BufferedReader inFromUser;	// Messages from the VRML client
	protected PrintStream outToVRML; 	// Messages to the VRML client PrintStream because PrintWriter doesn't work

	static String SWIProlog; // = "/Progra~1/pl/bin/plwin";
	static String dossierUlysse; // = "/windows/bureau/Ulysse/";
	static String dossierUlysseProlog; // = "/windows/bureau/Ulysse/prolog/";
	static String debutProlog; // = "boucle_entree.pl";
	static String monde_prolog; // = "monde.pl";
	static String executableProlog; // = "ulysse";

	static String commande;
	static String clauseProlog;
	static String nouvelObjet;
	static String messageProlog;

	int nombreObjets = 0; 	// Le nombre d'objets. Actuellement cach dans le serveur
					// Ultrieurement  transmettre  l'agent
	float x, y, z;
	float r1, r2, r3;
	float alpha;

	ConnexionServeur(Socket client) {
		FileInputStream fichierProprietes;
		java.util.Properties props = new java.util.Properties();

		this.client = client;
		System.out.println("Dmarrage d'une connexion");
		try {
			fichierProprietes = new FileInputStream(Connex.fichierInit);
			props.load(fichierProprietes);
		} catch (IOException e) {
			System.out.println("Fichier de proprits Ulysse.ini pas trouv ou pas bien charg " + e);
			return;
		}
		System.out.println("Lecture des proprits");
		props.list(System.out);
		SWIProlog = props.getProperty("connex.SWIProlog");
		dossierUlysse = props.getProperty("connex.dossierUlysse");
		dossierUlysseProlog = props.getProperty("connex.dossierUlysseProlog");
		executableProlog = props.getProperty("connex.executableProlog");
		debutProlog = props.getProperty("connex.debutProlog");
		monde_prolog = props.getProperty("connex.monde_prolog");
		// Connexion des sockets
		try {
			inFromUser = new BufferedReader(new InputStreamReader(client.getInputStream()));
			outToVRML = new PrintStream(client.getOutputStream());
		} catch (IOException e) {
			System.out.println("chec dans la connexion des sockets client " + e);
			return;
		}
		// Lancement du Prolog et redirection des E/S
		try {
			commande = dossierUlysseProlog + executableProlog;
			//commande = "plcon -g \"load_files('\\windows\\bureau\\ulysse\\prolog\\boucle_entree.pl', [silent(true)])\" -t on_demarre"; Ne marche pas. Pourquoi?
			prologProcess = Runtime.getRuntime().exec(commande); //"c:\\windows\\bureau\\Ulysse\\ulysse
			System.out.println("Prolog lanc");
			inFromProlog = new BufferedReader(new InputStreamReader(prologProcess.getInputStream()));
			outToProlog = new PrintWriter(prologProcess.getOutputStream());
			System.out.println("E/S rediriges");

			outToVRML.println("Serveur et moteur linguistique en marche");
		} catch (IOException e) {
			System.out.println("chec du lancement du Prolog " + e);
			return;
		}
	}

// Mthode pour ajouter un nouvel objet du monde.
// Elle fabrique deux clauses :
// objet#(x, y, x, vx, vy, vz, taille, adjs)
// objet(objet, #)
// La mthode les ajoute ensuite au fichier monde.pl
	public void assertNewObject(String ordre) {
		String typeObjet = "", nomObjet = "";
		String adjectifs = "";
		float centreX = 0.0F, centreY = 0.0F, centreZ = 0.0F;
		float vecteurX = 0.0F, vecteurY = 0.0F, vecteurZ = 0.0F;
		float taille = 0.0F;


		if (ordre.charAt(0) != '@') {
			System.out.println("Erreur dans assertNewObject");
			return; // cette ligne ne devrait pas tre excute
		}
		ordre = ordre.substring(1); // on saute le @
		StringTokenizer tokens = new StringTokenizer(ordre, " ");
					
		if(tokens.hasMoreTokens()) {
			typeObjet = tokens.nextToken();
			System.out.println(nomObjet);
		}
		if(tokens.hasMoreTokens()) {
			centreX = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(centreX);
		}
		if(tokens.hasMoreTokens()) {
			centreY = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(centreY);
		}
		if(tokens.hasMoreTokens()) {
			centreZ = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(centreZ);
		}
		if(tokens.hasMoreTokens()) {
			vecteurX = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(vecteurX);
		}
		if(tokens.hasMoreTokens()) {
			vecteurY = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(vecteurY);
		}
		if(tokens.hasMoreTokens()) {
			vecteurZ = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(vecteurZ);
		}
		if(tokens.hasMoreTokens()) {
			taille = Float.valueOf(tokens.nextToken()).floatValue();
			System.out.println(taille);
		}
		if (tokens.hasMoreTokens()) {
			adjectifs = tokens.nextToken();
			System.out.println(adjectifs);
		}
/*
		if(tokens.hasMoreTokens()) {
			nombreObjets = Integer.valueOf(tokens.nextToken()).intValue();
		}
*/
		nombreObjets++;
		nomObjet = typeObjet + nombreObjets;
		nouvelObjet = "objet" + "([" + typeObjet + ", " + nomObjet + ", ";
		nouvelObjet = nouvelObjet + centreX + ", " + centreY + ", " + centreZ + ", " + vecteurX + ", " + vecteurY + ", " + vecteurZ + ", " + taille + ", " + adjectifs + "])";
		System.out.println("Nouvel objet Prolog : " + nouvelObjet);
	}
		

	// Cette mthode envoie les ordres de translation et rotation  VRML
	public void sendMotionsToVRML(String ordre, PrintStream outToVRML) {
		byte c = 0;
		float x = 0.0F, y = 0.0F, z = 0.0F;
		float alpha = 0.0F;
		
		StringTokenizer tokens = new StringTokenizer(ordre, " ");
		String chaineCommande = "";

		if (tokens.hasMoreTokens()) {
			String tampon;
			tampon = tokens.nextToken();
			c = (byte) tampon.charAt(0);
		}
		if (c == 'e') {
			System.out.println("Java -> VRML : e");
			outToVRML.println("e");
			return;
		}
		if (c == 's') {
			System.out.println("Java -> VRML : s");
			outToVRML.println("s");
			return;
		}
		if (tokens.hasMoreTokens()) {
			x = Float.valueOf(tokens.nextToken()).floatValue();
		}
		if (tokens.hasMoreTokens()) {
			y = Float.valueOf(tokens.nextToken()).floatValue();
		}
		if (tokens.hasMoreTokens()) {
			z = Float.valueOf(tokens.nextToken()).floatValue();
		}
		if ((c == 'r') && tokens.hasMoreTokens()) {
			alpha = Float.valueOf(tokens.nextToken()).floatValue();
		}

		//Combinaison de t et r.
		if (c == 'c') {
			// La translation			
			chaineCommande = "c " + String.valueOf(x) + " " + String.valueOf(y) + " " + String.valueOf(z);
			// la rotation
			chaineCommande = chaineCommande + " 0 1 0 " + String.valueOf(alpha);
			// Envoi vers VRML
			outToVRML.println(chaineCommande + "\n");
			try { sleep(1000); } catch (InterruptedException e) {}
		
		}
		// Translation
		if (c == 't') {
			chaineCommande = "t " + String.valueOf(x) + " " + String.valueOf(y) + " " + String.valueOf(z);
			// Envoi vers VRML
			outToVRML.println(chaineCommande);
			try { sleep(1000); } catch (InterruptedException e) {}
		}
		// Rotation
		if (c == 'r') {
			chaineCommande = "r 0 1 0 " + String.valueOf(alpha);
			// Envoi vers VRML
			outToVRML.println(chaineCommande);
			try { sleep(1000); } catch (InterruptedException e) {}
		}
		System.out.println("Java -> VRML : " + chaineCommande);

	}

	// Analyse des lignes crites par le Prolog
	// Il y avait trois paramtres, dont un pour le canal de communication
	public Vector readLinesFromProlog() {
		Vector prologLines = new Vector();
		String buffer = new String();
		
		try { 
			sleep(1000);
		} catch (InterruptedException e) {
			return null;
		}
		try { 
			if (!inFromProlog.ready()) return null;
		} catch (IOException e) {
			return null;
		}
		while (true) {
			try {
				buffer = inFromProlog.readLine();
				System.out.println("Prolog -> Java " + buffer);
			} catch (IOException e) {
				break;
			}
			if (buffer != null) {
				if (buffer.startsWith("|:")) {
					buffer = buffer.substring(2);
				}
				prologLines.addElement(buffer);
				if (buffer.startsWith("#p")) {
					break;
				}
			}
		}
		return prologLines;
	}

	public void run() {
		String entree;
		String coordonnees;
		String ordre;
		int indexBarre = 0; // l'indice du sparateur | dans la commande du client
		Vector prologLines;

		// Une premire lecture de la sortie du moteur linguistique
		// Elle vide les messages inutiles et elle lit le nombre d'objets.
		while ((prologLines = readLinesFromProlog()) == null)
			;
		for (int i = 0; i < prologLines.size(); i++) {
			if (((String) prologLines.elementAt(i)).startsWith("#n")) {
				nombreObjets = Integer.valueOf(((String) prologLines.elementAt(i)).substring(2)).intValue();
				System.out.println("Prolog -> Java, nombre d'objets : " + nombreObjets);
			}
		}
		while (true) {
			try {
				entree = inFromUser.readLine();
			} catch (Exception e) {
				System.out.println(" Une exception dans la rception de donnes de VRML" + e);
				continue; //Ici changement  tester avec Cosmo
			}
			System.out.println("VRML -> Java : " + entree);
			// Analyse du sparateur |
			indexBarre = entree.indexOf('|');
			coordonnees = entree.substring(0, indexBarre);
			ordre = entree.substring(indexBarre + 1, entree.length());
			
			if (ordre.startsWith("bye")) {
				System.out.println("Fin de la connexion");
				break;
			}
			if (ordre.charAt(0) == '@') {
				// Ajoute le nouvel objet au monde Prolog
				assertNewObject(ordre);
				clauseProlog = "ajoute_objet" + "(" + nouvelObjet + ").";
				//Ici on envoie la clause puis l'ordre au prolog
				outToProlog.println(clauseProlog);
				System.out.println("Java -> Prolog : " + clauseProlog);
				continue;
			} 

			StringTokenizer tokens = new StringTokenizer(coordonnees, " ");
			if (tokens.hasMoreTokens()) {
				x = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				y = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				z = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				r1 = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				r2 = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				r3 = Float.valueOf(tokens.nextToken()).floatValue();
			}
			if (tokens.hasMoreTokens()) {
				alpha = Float.valueOf(tokens.nextToken()).floatValue();
			}
			clauseProlog = "moi([" + x + ", " + y + ", " + z + ", " + alpha * r2 + "]).";
				
			//Ici on envoie la clause puis l'ordre au prolog
			outToProlog.println(clauseProlog);
			outToProlog.flush();
			outToProlog.println(ordre);
			outToProlog.flush();
			
			System.out.println("Java -> Prolog : " + clauseProlog + " " + ordre);
				
			// Ici, lire la rponse du Prolog. L'entier est  regarder
			while ((prologLines = readLinesFromProlog()) == null)
				;
			for (int i = 0; i < prologLines.size(); i++) {
				if (((String) prologLines.elementAt(i)).startsWith("#n")) {
					nombreObjets = Integer.valueOf(((String) prologLines.elementAt(i)).substring(2)).intValue();
					System.out.println("Prolog -> Java, nombre d'objets : " + nombreObjets);
				}
				if (((String) prologLines.elementAt(i)).startsWith("&1")) {
					sendMotionsToVRML(((String) prologLines.elementAt(i)).substring(2), outToVRML);
				}
				if (((String) prologLines.elementAt(i)).startsWith("#p")) {
					break;
				}
			}		
			// ?? a completer
			//sleep(1000);
			System.out.println("Un tour");
		}
		// On arrte le Prolog en cours
		clauseProlog = "halt.";
		//Ici on envoie la clause au prolog
		outToProlog.println(clauseProlog);
		outToProlog.flush();
		prologProcess.destroy();
		try {
			prologProcess.exitValue();
		} catch (IllegalThreadStateException e) {}
		
		System.out.println("Java -> Prolog : " + clauseProlog);
		
		try {
			client.close();
		} catch (IOException e) {
			System.out.println(" Une exception dans la fermeture de la connexion VRML" + e);
		}
	}
}