import java.awt.*;

// The object naming frame that enable to name and describe a
// new object in the world

public class LearnNewObjectFrame extends java.awt.Frame {
	String coordinates;
	String nom, adjectif1, adjectif2, genre;
	Panel one, two, three;
	Button nouv, dev, der, voir, fin, ok;
	TextField nomTxtFld, adjectif1TxtFld, adjectif2TxtFld;
	Choice genreChoice;
	TextField devx, devy, devz, derx, dery, derz;
	TextField centrex, centrey, centrez;
	TextField vecteurx, vecteury, vecteurz;
	TextField taille;

	int etat;
	boolean nouveauDeplacement = false;


	static final int INIT = 0, VALIDER = 15, INTERROMPU = 999;
	static final int DESCRIPTION_ENCOURS = 5;
	static final int DEVANT_DEFINI = 2, DERRIERE_DEFINI = 8;
	static final int DEV_DER_DEFINIS = 12, DER_DEV_DEFINIS = 18, VOIR = 20;
	static final int VA_DERRIERE = 28, VA_DEVANT = 22;

	LearnNewObjectFrame(String title) {
		super(title);
		etat = INIT;
		nom = new String("");
		adjectif1 = new String("");
		adjectif2 = new String("");
		genre = new String("");
		coordinates = new String("    ");

		nouv = new Button("Nouvel objet");
		dev = new Button("->Devant");
		der = new Button("Derrire<-");
		voir = new Button("Voir caractristiques");
		fin = new Button("Interrompre");
		ok = new Button("Valider");
		ok.disable();

		nomTxtFld = new TextField(nom);
		adjectif1TxtFld = new TextField(adjectif1);
		adjectif2TxtFld = new TextField(adjectif2);

		genreChoice = new Choice();
		genreChoice.addItem("Masculin");
		genreChoice.addItem("Fminin");

		nomTxtFld.setEditable(false);		// User can enter name and description
		adjectif1TxtFld.setEditable(false);	// when new object is selected
		adjectif2TxtFld.setEditable(false);
 
		setLayout(new BorderLayout());

		one = new Panel();
		two = new Panel();
		three = new Panel();
		add("North", one);
		add("Center", two);
		add("South", three);

		one.setLayout(new GridLayout(2,4));
		one.add(new Label("Nom"));
		one.add(nomTxtFld);
		one.add(new Label("Genre"));
		one.add(genreChoice); 
		one.add(new Label("Adjectif (1er)"));
		one.add(adjectif1TxtFld); 
		one.add(new Label("Adjectif (2e)"));
		one.add(adjectif2TxtFld); 

		two.setLayout(new GridLayout(5,4));
		two.add(dev);
		devx = new TextField(coordinates);
		devx.setEditable(false);
		two.add(devx);
		devy = new TextField(coordinates);
		devy.setEditable(false);
		two.add(devy);
		devz = new TextField(coordinates);
		devz.setEditable(false);
		two.add(devz);

		two.add(der);
		derx = new TextField(coordinates);
		derx.setEditable(false);
		two.add(derx);
		dery = new TextField(coordinates);
		dery.setEditable(false);
		two.add(dery);
		derz = new TextField(coordinates);
		derz.setEditable(false);
		two.add(derz);

		two.add(new Label("Centre"));
		centrex = new TextField(coordinates);
		centrex.setEditable(false);
		two.add(centrex);
		centrey = new TextField(coordinates);
		centrey.setEditable(false);
		two.add(centrey);
		centrez = new TextField(coordinates);
		centrez.setEditable(false);
		two.add(centrez);

		two.add(new Label("Vecteur"));
		vecteurx = new TextField(coordinates);
		vecteurx.setEditable(false);
		two.add(vecteurx);
		vecteury = new TextField(coordinates);
		vecteury.setEditable(false);
		two.add(vecteury);
		vecteurz = new TextField(coordinates);
		vecteurz.setEditable(false);
		two.add(vecteurz);

		two.add(new Label("Taille"));
		taille = new TextField(coordinates);
		taille.setEditable(false);
		two.add(taille);
		

		three.setLayout(new FlowLayout());
		three.add(nouv);
		three.add(voir);
		three.add(fin);
		three.add(ok);

	}
	
	public boolean action(java.awt.Event evt, Object arg) {
		if (evt.target instanceof Button) {
			if (((String)arg).equals("Interrompre")) {
				etat = INTERROMPU;
				nouveauDeplacement = true;
				nouv.enable();
			}
			if (etat > 0) {
				if (((String)arg).equals("->Devant")) {
					etat = DEVANT_DEFINI;
					nouveauDeplacement = true;
					dev.setLabel("--Devant");
					if ((der.getLabel()).equals("Derrire--")) {
						etat = DEV_DER_DEFINIS;
						ok.enable();
					}
				}
				if (((String)arg).equals("Derrire<-")) {
					etat = DERRIERE_DEFINI;
					nouveauDeplacement = true;
					der.setLabel("Derrire--");
					if ((dev.getLabel()).equals("--Devant")) {
						etat = DER_DEV_DEFINIS;
						ok.enable();
					}
				}
				if (((String)arg).equals("Voir caractristiques")) {
					etat = VOIR;
					nouveauDeplacement = true;
				}
				if (((String)arg).equals("Derrire--")) {
					etat = VA_DERRIERE;
					nouveauDeplacement = true;
				}
				if (((String)arg).equals("--Devant")) {
					etat = VA_DEVANT;
					nouveauDeplacement = true;
				}
				if (((String)arg).equals("Valider")) { 
					etat = VALIDER;
					nom = nomTxtFld.getText();
					adjectif1 = adjectif1TxtFld.getText();
					adjectif2 = adjectif2TxtFld.getText();
					genre = genreChoice.getSelectedItem();
					if (!nom.equals(""))
						nouveauDeplacement = true;
					nomTxtFld.setText("");
					adjectif1TxtFld.setText("");
					adjectif2TxtFld.setText("");
					nomTxtFld.setEditable(false);
					adjectif1TxtFld.setEditable(false);
					adjectif2TxtFld.setEditable(false);
					dev.setLabel("->Devant");
					der.setLabel("Derrire<-"); 
					devx.setText("");
					devy.setText("");
					devz.setText("");
					derx.setText("");
					dery.setText("");
					derz.setText("");
					centrex.setText("");
					centrey.setText("");
					centrez.setText("");
					vecteurx.setText("");
					vecteury.setText("");
					vecteurz.setText("");
					taille.setText("");

					ok.disable();
					nouv.enable();
				}
			}
			if (((String)arg).equals("Nouvel objet")) {
				nomTxtFld.setEditable(true);
				adjectif1TxtFld.setEditable(true);
				adjectif2TxtFld.setEditable(true);
				etat = DESCRIPTION_ENCOURS;
				nomTxtFld.setText("");
				adjectif1TxtFld.setText("");
				adjectif2TxtFld.setText("");
				dev.setLabel("->Devant");
				der.setLabel("Derrire<-");
				devx.setText("");
				devy.setText("");
				devz.setText("");
				derx.setText("");
				dery.setText("");
				derz.setText("");
				centrex.setText("");
				centrey.setText("");
				centrez.setText("");
				vecteurx.setText("");
				vecteury.setText("");
				vecteurz.setText("");
				taille.setText("");
				ok.disable();
				nouv.disable();
			}
		}
		return true;
	}
}

