// Ulysse Version 0.8.6
/**
@version 0.8.6
*/

import vrml.*;
import vrml.field.*;
import vrml.node.*;
import java.io.*;
import java.net.*;
import java.util.*;

import LearnNewObjectFrame;
import CommandFrame;
import PositionFrame;
import InfoFrame;

public class Ulysse extends Script implements Runnable {
	private String languageEngineServer = "localhost";
										//"localhost";  choisir pour une machine locale
										//"penelope.greyc.ismra.fr";
										//"www.info.unicaen.fr";
										//"e450.ensicaen.ismra.fr";
                                                                                //"users.info.unicaen.fr";
	private SFFloat fraction;
	private SFVec3f position_changed;
	private MFVec3f position_inter;
	private SFBool timer;
	private SFFloat instant_changed;

	private SFRotation rotation_changed;

	private MFRotation rotation_inter;
	private ConstSFVec3f position_actuelle;
	private ConstSFRotation rotation_actuelle;
	private SFBool relie_changed1;
	private SFBool relie_changed2;
	private float i;
	
	private float instant;	// Timebase used by the avatar
	private boolean moving = false;

	private boolean demi_tour = false;
	private SFVec3f demitourpos_changed;
	private SFRotation demitourrot_changed;

        // Inline init of some vectors and rotations. Not sure it's completely orthodox. I had to move it here because of compiler errors with the Sun's JDK
	private SFVec3f vecteur_null = new SFVec3f((float) 0.0, (float) 0.0, (float) 0.0);
	private SFRotation rotation_null = new SFRotation((float) 0.0, (float) 1.0, (float) 0.0, (float) 0.0);
	private SFRotation rotation_demi_tour = new SFRotation((float) 0.0, (float) 1.0, (float) 0.0, (float) Math.PI);	
        private SFVec3f avanceunpeu = new SFVec3f((float) 0.0, (float) 0.0, (float) (Math.PI/2));
	private SFVec3f reculeunpeu = new SFVec3f((float) 0, (float) 0, (float) - (Math.PI/2));

	private boolean devant = false;
	private float Devant_pos[];
	private float Devant_rot[];
	private int nbr_objet = 0;
	private boolean derriere = false;
	private float Derriere_pos[];
	private float Derriere_rot[];

	static final int INIT = 0, VALIDER = 15, INTERROMPU = 999;
	static final int DESCRIPTION_ENCOURS = 5;
	static final int DEVANT_DEFINI = 2, DERRIERE_DEFINI = 8;
	static final int DEV_DER_DEFINIS = 12, DER_DEV_DEFINIS = 18, VOIR = 20;
	static final int VA_DERRIERE = 28, VA_DEVANT = 22;

	private String noServer = "Le serveur linguistique n\'est pas en marche!\n"
			+ "Vous pouvez dplacer l\'avatar avec les commandes suivantes :\n"
			+ "- pour une translation &1t x y z\n"
			+ "- pour une rotation &1r x y z thta\n"
			+ "- pour une translation et une rotation simultanes &1c x y z xr yr zr thta";


	private float user;
	private int ancien_xx = 5000, ancien_yy = 0, ancien_zz = 0;
	private int ancien_rr0 = 5000, ancien_rr1 = 0, ancien_rr2 = 0, ancien_rr3 = 0;

	Thread evenements = null, communication = null, mouvement = null;

	LearnNewObjectFrame namingWindow;
	CommandFrame commandWindow;
	PositionFrame positionWindow;
	InfoFrame infoFrame;

	private boolean firstRotation = true; 	// The rotation axis is inited with 
							// the orientation of the avatar.
							// We must take care of it and
							// replace it with vertical axis 
							// when the first move occurs.
	private boolean orientationInited = false;

	boolean connectedToServer = false;
	boolean fin_mouvement = false;

	InputStream sinFromProlog = null;  // Stream from the Prolog language engine
	OutputStream soutToProlog = null; // Stream to the Prolog language engine

	Socket s = null;
	
	// Le vecteur des ordres reus
	private Vector receivedOrders;
	
	// Les caractristiques de l'objet
	private String [] objectFeatures = new String[9];

	private String chaine;
        
	// Threads are kicked off
	public void start() {
		if (evenements == null) {
			evenements = new Thread(this, "vnements");
			System.out.println(Thread.currentThread().getName() + " dmarrage");
			evenements.start();
		}
		if (communication == null) {
			communication = new Thread(this, "Communication");
			System.out.println(Thread.currentThread().getName() + " dmarrage");
			communication.start();
		}
		if (mouvement == null) {
			mouvement = new Thread(this, "Mouvement");
			System.out.println(Thread.currentThread().getName() + " dmarrage");
			mouvement.start();
		}
	}
	public void stop() {
		sendAvPositionAndOrderToProlog("bye.");
		stop_communication();
		stop_mouvement();
		stop_evenements();
		namingWindow.hide();
		commandWindow.hide();
		positionWindow.hide();
	}

	public void stop_evenements() {
		if (evenements != null) {
			evenements = null;
		}
	}

	public void stop_communication() {
		try { 
			if (s != null) s.close(); 
		} 
		catch (IOException except) {
		}
		if (communication != null) {
			communication = null;
		}
	}

	public void stop_mouvement() {
		if (mouvement != null) {
			mouvement = null;
		}
	}

	public void run() {
		if ((Thread.currentThread().getName()).equals("vnements")) {
			System.out.println(Thread.currentThread().getName() + " dmarr");
			eventLoop();
		}
		if ((Thread.currentThread().getName()).equals("Mouvement")) {
			System.out.println(Thread.currentThread().getName() + " dmarr");
			executeAction();
		}
		if ((Thread.currentThread().getName()).equals("Communication")) {
			System.out.println(Thread.currentThread().getName() + " dmarr");
			receiveFromServer();
		}
	}

	public void sendAvPositionAndOrderToProlog(String verbalCommand) {
		float pos[], rot[];
		pos = new float[3];
		rot = new float[4];
		if (connectedToServer) {
			PrintStream psout = new PrintStream(soutToProlog);
			position_actuelle.getValue(pos);
			rotation_actuelle.getValue(rot);
			// We make the Y axis positive to standardize representation
			if (rot[1] < 0) {
				rot[0] = - rot[0];
				rot[1] = - rot[1];
				rot[2] = - rot[2];
				rot[3] = - rot[3];
			}
			System.out.println("Coords actuelles passes au Prolog : " + 
				pos[0] + " " + pos[1] + " " +  pos[2]);
			System.out.println("Angle actuel pass au Prolog : " + 
				rot[0] + " " + rot[1] + " " +  rot[2] + " " + rot[3]);

			// Coordinates and verbal command sent to Prolog 
			psout.println(pos[0] + " " + pos[1] + " " + pos[2] + " " + 
				rot[0] + " " + rot[1] + " " + rot[2] + " " + rot[3] + "|" +
				verbalCommand);

		}
	}
	
	// Initialization of the interpolation.
	// 5 equal key values that are transmitted 
	// to MoveTrans and MoveRot : Present location and rotation.
	// A subsequent translation (resp rotation) will only 
	// modify the translation (resp rotation) keys and the mover 
	// won't do undesired rotation (resp translation).
	public void init_interp(float actuel[]) {
		int i;
		float pos[][] = new float[5][3];
		float rot[][] = new float[5][4];
		for (i = 0; i < 5; i++) {
			pos[i][0] = actuel[0];
			pos[i][1] = actuel[1];
			pos[i][2] = actuel[2];

			rot[i][0] = actuel[3];
			rot[i][1] = actuel[4];
			rot[i][2] = actuel[5];
			rot[i][3] = actuel[6];
		/*	rot[i][0] = 0;
			rot[i][1] = 1;
			rot[i][2] = 0;
			rot[i][3] = 0; */
		}
		rectifie_vue();
		position_inter.setValue(pos);
		rotation_inter.setValue(rot);
	}


	public void opere_translation(float tab_trans[]) {
		float t = 1F;
		float tab[][] = new float[5][3];
		rectifie_vue();
		affiche("Translation : " + tab_trans[0] + " " + tab_trans[1] + " " + 
			tab_trans[2] + " -> " + tab_trans[3] + " " 
			+ tab_trans[4] + " " + tab_trans[5] +  " ");

		System.out.print("Translation : ");
		System.out.print(tab_trans[0] + " " + tab_trans[1] + " " + tab_trans[2] + " > ");
		System.out.println(tab_trans[3] + " " + tab_trans[4] + " " + tab_trans[5]);

		tab[0][0] = tab_trans[0];
		tab[0][1] = tab_trans[1];
		tab[0][2] = tab_trans[2];

		tab[4][0] = tab_trans[3];
		tab[4][1] = tab_trans[4];
		tab[4][2] = tab_trans[5];

		for (int j = 1; j < 4; j++)
			for (int k = 0; k < 3; k++)
				tab[j][k] = tab[0][k] + j*(tab[4][k] - tab[0][k])/4;

		//   affiche("INSTANT T ++++++++++++++++++++++" + instant);
		System.out.println("INSTANT T ++++++++++++++++++++++"+instant);
		position_inter.setValue(tab);
		timer.setValue(true);

	}

	public void opere_rotation(float tab_rot[]) {
		float tab[][] = new float[5][4];
                double angleRot;
                
		rectifie_vue();
		affiche("Rotation : " + tab_rot[0] + " " + tab_rot[1] + " " + tab_rot[2] + " " + tab_rot[3] + " -> " 
                    + tab_rot[4] + " " + tab_rot[5] +  " " + tab_rot[6] + " " + tab_rot[7]);

		System.out.print("Rotation : ");
		System.out.print(tab_rot[0] + " " + tab_rot[1] + " " + tab_rot[2] + " " + tab_rot[3] + " > ");
		System.out.println(tab_rot[4] + " " + tab_rot[5] +  " " + tab_rot[6] + " " + tab_rot[7]);
		//  if ((tab_rot[0] == tab_rot[4])&&(tab_rot[1] == tab_rot[5])&&(tab_rot[2] == tab_rot[6])) tab[0][3]= tab_rot[4];
		//  else tab[0][3] = 0;

		if (firstRotation) {
			// The rotation axis is inited with the orientation of the avatar.
			// We must take care of it and replace it with vertical axis 
			// when the first move occurs.

			tab[0][0] = 0;
			tab[0][1] = 1;
			tab[0][2] = 0;
			tab[0][3] = 0;
			firstRotation = false;
		} else {
			tab[0][0] = tab_rot[0];
			tab[0][1] = tab_rot[1];
			tab[0][2] = tab_rot[2];
			tab[0][3] = tab_rot[3];
		}
		tab[4][0] = tab_rot[4];
		tab[4][1] = tab_rot[5];
		tab[4][2] = tab_rot[6];
		tab[4][3] = tab_rot[7];

		// On va mettre les Y en positif pour normaliser la reprsentation
		if (tab[0][1] < 0) {
			tab[0][1] = - tab[0][1];
			tab[0][3] = - tab[0][3];
		}
		if (tab[4][1] < 0) {
			tab[4][1] = - tab[4][1];
			tab[4][3] = - tab[4][3];
		}
                
                // Calcul du sens pour que la rotation soit la plus petite
                angleRot = Math.floor((tab[4][3] - tab[0][3])/(2*Math.PI));
                angleRot =  (tab[4][3] - tab[0][3]) - 2 * Math.PI * angleRot;
		if (angleRot > Math.PI)
                    angleRot -= 2*Math.PI;
                if (angleRot < -Math.PI)
                    angleRot += 2*Math.PI;
                tab[4][3] = tab[0][3] + (float) angleRot;
		for (int j = 1; j < 4; j++)
			for (int k = 0; k < 4; k++)
				tab[j][k] = tab[0][k] + j*(tab[4][k] - tab[0][k])/4;

		rotation_inter.setValue(tab);
		affiche("INSTANT R ++++++++++++++++++++++"+instant);
		System.out.println("INSTANT R ++++++++++++++++++++++" + instant);
		timer.setValue(true);
	}

	public void opere_translation_rotation(float tab[]) {
		float t = 1F;
		float tab_pos[][] = new float[5][3];
		float tab_rot[][] = new float[5][4];
                double angleRot;

		rectifie_vue();
		affiche("Translation : " + tab[0] + " " + tab[1] + " " + tab[2] + " -> " + tab[7] + " " + tab[8] + " " + tab[9] +  " ");
                affiche("Rotation : " + tab[3] + " " + tab[4] + " " + tab[5] + " " + tab[6] + " -> "
                    + tab[10] + " " + tab[11] +  " " + tab[12] + " " + tab[13]);

		
                // Initial positions and rotation axis
		tab_pos[0][0] = tab[0];
		tab_pos[0][1] = tab[1];
		tab_pos[0][2] = tab[2];

		tab_rot[0][0] = tab[3];
		tab_rot[0][1] = tab[4];
		tab_rot[0][2] = tab[5];
		tab_rot[0][3] = tab[6];

		// End position and rotation axis
		tab_pos[4][0] = tab[7];
		tab_pos[4][1] = tab[8];
		tab_pos[4][2] = tab[9];

		tab_rot[4][0] = tab[10];
		tab_rot[4][1] = tab[11];
		tab_rot[4][2] = tab[12];
		tab_rot[4][3] = tab[13];

                // Calcul du sens pour que la rotation soit la plus petite
                angleRot = Math.floor((tab_rot[4][3] - tab_rot[0][3])/(2*Math.PI));
                angleRot =  (tab_rot[4][3] - tab_rot[0][3]) - 2 * Math.PI * angleRot;
		if (angleRot > Math.PI)
                    angleRot -= 2*Math.PI;
                if (angleRot < -Math.PI)
                    angleRot += 2*Math.PI;
                tab_rot[4][3] = tab_rot[0][3] + (float) angleRot;

		for (int j = 1; j < 4; j++)
			for (int k = 0; k < 3; k++)
				tab_pos[j][k] = tab_pos[0][k] + j*(tab_pos[4][k] - tab_pos[0][k])/4;

		for (int j = 1; j < 4; j++)
			for (int k = 0; k < 4; k++)
				tab_rot[j][k] = tab_rot[0][k] + j*(tab_rot[4][k] - tab_rot[0][k])/4;


		affiche("INSTANT T ++++++++++++++++++++++" + instant);
		position_inter.setValue(tab_pos);
		rotation_inter.setValue(tab_rot);
		timer.setValue(true);
	}

	//  while ((t>=0) && (fin_mouvement == false)) {
		//    affiche("opere_translation, t = "+t);
		//    t-=0.01F;
		//    affiche(" "+tab[3]+" "+tab[4]+" "+tab[5]+" ");
		//    position_changed.setValue(t*tab[0]+(1-t)*tab[3], t*tab[1]+(1-t)*tab[4], t*tab[2]+(1-t)*tab[5]);
		//    try{ 
//			Thread.sleep(10); 
//		} 
//		catch (InterruptedException ignored) { 
//			return; 
//		}
		//   	}
	//   rectifie_vue();
	//   fin_mouvement=false;
	//  }

	public boolean connectToLanguageEngine() {
		System.out.println("Connexion au moteur linguistique...");
		try {
			s = new Socket(languageEngineServer, 2040);
			System.out.println("Connect  " + s.getInetAddress() + 
				":" + s.getPort());
			sinFromProlog = s.getInputStream();
			soutToProlog = s.getOutputStream();
			return true;
		} catch (IOException except) {
			System.out.println("chec de connexion au serveur ou d'obtention d'un flux : " + except); 
			return false;
		}
	}

	// This thread updates the avatar's position.
	// When the avatar is moving or if there are no orders, we wait
	// else we process orders and we launch the motion
	public void executeAction() {
		float tf[];
		float tactu_pos[];
		float tactu_rot[];
		float tab[];
		char ordre;
		int i;

		tf = new float[7];	// Coordinates of the end position
		tactu_pos = new float[3];
		tactu_rot = new float[4];

		tab = new float[14];

//Maintenant la boucle d'excution. Avant d'y rentrer, il faudrait vrifier que
// l'analyseur est en marche et le sortir de cette boucle.

		while (true) {
			//   affiche(Thread.currentThread().getName());
			//System.out.println(Thread.currentThread().getName() + ", inst: " + instant);
			if (moving) {
				// The avatar is moving. We just wait.
				try{ 
					Thread.sleep(1000); 
				} 
				catch (InterruptedException ignored) { 
					return; 
				}
			}
			else if (receivedOrders.size() == 0) {
				// There is no command. We wait.
				try{ 
					Thread.sleep(1000); 
				} 
				catch (InterruptedException ignored) { 
					return; 
				}

			} else {
				// There are commands. We are to process them.
				chaine = (String) receivedOrders.firstElement();
				receivedOrders.removeElementAt(0);
				System.out.println("La chane  analyser " + chaine);

			// The first command. Just indicates that the
			// the language engine is on. This initializes the avatar
				if (chaine.equals("Moteur linguistique en marche")) {
					position_actuelle.getValue(tactu_pos);
					rotation_actuelle.getValue(tactu_rot);
					// La position initiale est verticale
					for (i = 0; i < 3; i++)
						tab[i] = tactu_pos[i];
					tab[3] = 0;
					tab[4] = 1;
					tab[5] = 0;
					tab[6] = 0;
					init_interp(tab);
				//	timer.setValue(true);
				//	for (i = 0; i < 3; i++)
				//		tab[i] = tactu_rot[i];
					// On positionne l'axe de l'avatar  la verticale
				//	opere_rotation(tab);

				}
			// There are real commands. Let's translate and rotate.
				else if (!chaine.equals("")) {
				//	affiche("executeAction, moving, instant : " + instant);
					System.out.println("executeAction, moving, instant : " + instant);
					moving = true;
					instant = 0.0f;
					// We get here the final coordinates
					// Le try est  revoir avec parseCoordinateString
					try {
						ordre = parseCoordinateString(chaine, tf);
						if (ordre == 'e') {
							System.out.println("Echec analyse");
							moving = false;
							continue;
						}
					}
					catch (Exception e) {
						System.out.println("Echec analyse");
						moving = false;
						continue; 
					}
				//	 affiche("----mouvement actuel------------>|" + chaine + ":" + ordre + "|" + tf[0] + "|" + tf[1] + "|" + tf[2] + "|" + tf[3] +  "|");
					position_actuelle.getValue(tactu_pos);
					rotation_actuelle.getValue(tactu_rot);
					for (i = 0; i < 3; i++)
						tab[i] = tactu_pos[i];
					for (i = 0; i < 4; i++)
						tab[i + 3] = tactu_rot[i];
					
					init_interp(tab);
					System.out.print("Chane initiale des ordres: ");
					System.out.println(ordre);

					if (ordre == 't') {
						for (i = 0; i < 3; i++)
							tab[i] = tactu_pos[i];
						for (i = 0; i < 3; i++)
							tab[i + 3] = tf[i];
						opere_translation(tab);
					}
					// Here we suppose that the final rotation axis
					// is the same as the start rotation axis
					if (ordre == 'r') {
						for (i = 0; i < 4; i++)
							tab[i] = tactu_rot[i];
						for (i = 0; i < 4; i++)
							tab[i + 4] = tf[i];
						opere_rotation(tab);
					}
					if (ordre == 'c') {
						for (i = 0; i < 3; i++)
							tab[i] = tactu_pos[i];
						for (i = 0; i < 4; i++)
							tab[i + 3] = tactu_rot[i]; 
						for (i = 0; i < 7; i++)
							tab[i + 7] = tf[i];
						opere_translation_rotation(tab);
					}
					if (ordre == 's') {
						// On ne fait rien.  complter
						continue;
					}

				}
			}

		}
	}

	// Receive orders from the language server
	public void receiveFromServer() {
		if (connectedToServer) {
			System.out.println("receiveFromServer");
			while(true) {
				affiche(Thread.currentThread().getName());
				try{ 
					Thread.sleep(1000); 
				} 
				catch (InterruptedException ignored) { 
					return; 
				}
				if (receivedOrders.size() < 30) {
					try {
						DataInputStream dsin = new DataInputStream(sinFromProlog);
						receivedOrders.addElement(dsin.readLine());
						affiche("Message reu " + receivedOrders.lastElement());
					//	System.out.println("Message recu " + 
					//		receivedOrders.lastElement());
					}
					catch (IOException except) {
						System.out.println("Erreur de rception " + except); 
						connectToLanguageEngine(); 
						start();
					}
					affiche("connectedToServer = " + connectedToServer);
				}
			}
		}
	}
	
	// The event loop process commands from the command input frame and
	// the learn new object frame
	public void eventLoop() {
		float x, y, z;
		while (true) {
			affiche(Thread.currentThread().getName());
			try{ 
				Thread.sleep(500); 
			} 
			catch (InterruptedException ignored) { 
				return; 
			}
			if (demi_tour == true) {
				demi_tour = false;
				System.out.println("Demi-tour");
				demitourrot_changed.setValue(rotation_demi_tour);
				demitourpos_changed.setValue(reculeunpeu);
			}
			if (!positionWindow.visible) {
				positionWindow.hide();
				commandWindow.coordinates.enable();
			}
			if (!connectedToServer) 
				if (!infoFrame.visible) {
					infoFrame.hide();
				}

			if (namingWindow.nouveauDeplacement) {
				namingWindow.nouveauDeplacement = false;
				if ((namingWindow.etat == DEVANT_DEFINI) 
					|| (namingWindow.etat == DEV_DER_DEFINIS)) {
					devant = true;
					position_actuelle.getValue(Devant_pos);
					rotation_actuelle.getValue(Devant_rot);
					namingWindow.devx.setText(Float.toString(Devant_pos[0]));
					namingWindow.devy.setText(Float.toString(Devant_pos[1]));
					namingWindow.devz.setText(Float.toString(Devant_pos[2]));

					rectifie_vue();
					if (namingWindow.etat < 10)
						demi_tour = true;
					else namingWindow.etat = VA_DEVANT;
				}
				if ((namingWindow.etat == DERRIERE_DEFINI) ||
						(namingWindow.etat == DER_DEV_DEFINIS)) {
					derriere = true;
					position_actuelle.getValue(Derriere_pos);
					rotation_actuelle.getValue(Derriere_rot);
					namingWindow.derx.setText(Float.toString(Derriere_pos[0]));
					namingWindow.dery.setText(Float.toString(Derriere_pos[1]));
					namingWindow.derz.setText(Float.toString(Derriere_pos[2]));

					rectifie_vue();
					if (namingWindow.etat < 10)
						demi_tour = true;
					else
						namingWindow.etat = VA_DERRIERE;
				}
				if (namingWindow.etat == VA_DERRIERE) {
					position_changed.setValue(Devant_pos);
					rotation_changed.setValue(Devant_rot);
				}
				if (namingWindow.etat == VA_DEVANT) {
					position_changed.setValue(Derriere_pos);
					rotation_changed.setValue(Derriere_rot);
				}
				if (namingWindow.etat == INTERROMPU) {
					namingWindow.hide();
					commandWindow.learnNewObject.enable();
				}
				if (namingWindow.etat == VOIR) {
					objectFeatures[1] = Double.toString((Derriere_pos[0] + Devant_pos[0])/2.0);
					objectFeatures[2] = Double.toString((Derriere_pos[1] + Devant_pos[1])/2.0);
					objectFeatures[3] = Double.toString((Derriere_pos[2] + Devant_pos[2])/2.0);
					objectFeatures[4] = Double.toString(Devant_pos[0] - (Derriere_pos[0] + Devant_pos[0])/2.0);
					objectFeatures[5] = Double.toString(Devant_pos[1] - (Derriere_pos[1] + Devant_pos[1])/2.0);
					objectFeatures[6] = Double.toString(Devant_pos[2] - (Derriere_pos[2] + Devant_pos[2])/2.0);
					objectFeatures[7] = Double.toString(Math.sqrt((Derriere_pos[0] - Devant_pos[0]) * 
						(Derriere_pos[0] - Devant_pos[0]) + 
						(Derriere_pos[1] - Devant_pos[1]) * 
						(Derriere_pos[1] - Devant_pos[1]) + 
						(Derriere_pos[2] - Devant_pos[2]) * 
						(Derriere_pos[2] - Devant_pos[2])) /2.0);
					namingWindow.centrex.setText(objectFeatures[1]);
					namingWindow.centrey.setText(objectFeatures[2]);
					namingWindow.centrez.setText(objectFeatures[3]);
					namingWindow.vecteurx.setText(objectFeatures[4]);
					namingWindow.vecteury.setText(objectFeatures[5]);
					namingWindow.vecteurz.setText(objectFeatures[6]);
					namingWindow.taille.setText(objectFeatures[7]);

				}
				if (namingWindow.etat == VALIDER) {
					namingWindow.etat = INIT;
					String adj_string = new String("");
					if ((namingWindow.adjectif1.equals("")) 
						&& ((namingWindow.adjectif2.equals(""))))
						adj_string = "[]";
					else if ((namingWindow.adjectif1.equals("")))
						adj_string = "[" + namingWindow.adjectif2 + "]";
					else if ((namingWindow.adjectif2.equals("")))
							adj_string = "[" + namingWindow.adjectif1 + "]";
					else
						adj_string = "[" + namingWindow.adjectif1 + "," + namingWindow.adjectif2 + "]";

					objectFeatures[0] = namingWindow.nom;
					objectFeatures[1] = Double.toString((Derriere_pos[0] + Devant_pos[0])/2.0);
					objectFeatures[2] = Double.toString((Derriere_pos[1] + Devant_pos[1])/2.0);
					objectFeatures[3] = Double.toString((Derriere_pos[2] + Devant_pos[2])/2.0);
					objectFeatures[4] = Double.toString(Devant_pos[0] - (Derriere_pos[0] + Devant_pos[0])/2.0);
					objectFeatures[5] = Double.toString(Devant_pos[1] - (Derriere_pos[1] + Devant_pos[1])/2.0);
					objectFeatures[6] = Double.toString(Devant_pos[2] - (Derriere_pos[2] + Devant_pos[2])/2.0);
					objectFeatures[7] = Double.toString(Math.sqrt((Derriere_pos[0] - Devant_pos[0]) * 
						(Derriere_pos[0] - Devant_pos[0]) + 
						(Derriere_pos[1] - Devant_pos[1]) * 
						(Derriere_pos[1] - Devant_pos[1]) + 
						(Derriere_pos[2] - Devant_pos[2]) * 
						(Derriere_pos[2] - Devant_pos[2])) /2.0);
					objectFeatures[8] = adj_string;

					sendAvPositionAndOrderToProlog("@ " + namingWindow.nom + 
					  " " + (Derriere_pos[0] + Devant_pos[0])/2.0 + 
					  " " + (Derriere_pos[1] + Devant_pos[1])/2.0 + 
					  " " + (Derriere_pos[2] + Devant_pos[2])/2.0 + 
					  " " + (Devant_pos[0] - (Derriere_pos[0] + Devant_pos[0])/2.0) + 
					  " " + (Devant_pos[1] - (Derriere_pos[1] + Devant_pos[1])/2.0) + 
					  " " + (Devant_pos[2] - (Derriere_pos[2] + Devant_pos[2])/2.0) + 
					  " " + Math.sqrt((Derriere_pos[0] - Devant_pos[0]) * (Derriere_pos[0] - Devant_pos[0]) + 
					  (Derriere_pos[1] - Devant_pos[1]) * (Derriere_pos[1]-Devant_pos[1]) + 
					  (Derriere_pos[2] - Devant_pos[2]) * (Derriere_pos[2]-Devant_pos[2]))/2.0 + 
					  " " + adj_string + " " + nbr_objet++);
					namingWindow.hide();
					commandWindow.learnNewObject.enable();
				}
			}
			if (!commandWindow.commandText.equals("")) {
				if (commandWindow.commandText.equals("apprentissage")) {
					namingWindow.show();
					commandWindow.commandText = "";
				}
				if (commandWindow.commandText.equals("coordonnes")) {
					positionWindow.show();
					positionWindow.visible = true;
					commandWindow.commandText = "";
				}
				if (commandWindow.commandText.equals("quitter")) {
					stop();
					commandWindow.commandText = "";
				}
// A direct vector order. It is directly interpreted without being transmitted to
// the language engine.
				if (commandWindow.commandText.startsWith("&1t") ||
				  commandWindow.commandText.startsWith("&1r") ||
				  commandWindow.commandText.startsWith("&1c")) {
					System.out.println(commandWindow.commandText);
					receivedOrders.addElement(commandWindow.commandText.substring(2));
					commandWindow.commandText = "";
				}
// A text order that is sent to the language engine
				if (!commandWindow.commandText.equals("")) {
					System.out.println(commandWindow.commandText);
					sendAvPositionAndOrderToProlog(commandWindow.commandText);
					commandWindow.commandText = "";
				}
			}
		}
	}

	public void initialize() {
		String hung;
                System.out.println("Init en cours...");
		connectedToServer = connectToLanguageEngine();
		if (connectedToServer) {
			try {
				DataInputStream dsin = new DataInputStream(sinFromProlog);
				hung = dsin.readLine();
				System.out.println("Message d'initialisation reu : " + hung);
			} catch (IOException except) {
				System.out.println(except);
			}
                }
		position_changed = (SFVec3f) getEventOut ("position_changed");
		rotation_changed = (SFRotation ) getEventOut ("rotation_changed");
		relie_changed1 = (SFBool) getEventOut("relie_changed1");
		relie_changed2 = (SFBool) getEventOut("relie_changed2");
		position_inter = (MFVec3f) getEventOut ("position_inter");
		rotation_inter = (MFRotation) getEventOut ("rotation_inter");
		timer = (SFBool) getEventOut ("timer");
		instant_changed = (SFFloat) getEventOut ("instant_changed");

		demitourpos_changed = (SFVec3f) getEventOut ("demitourpos_changed");
		demitourrot_changed = (SFRotation) getEventOut ("demitourrot_changed");
		
		i = (float) 0.0;
		user = (float) 0.0 ;
		Devant_pos = new float[3];
		Devant_rot = new float[4];

		Derriere_pos = new float[3];
		Derriere_rot = new float[4];

		receivedOrders = new Vector();
		
		chaine = new String("");


		//Monthread = new mythread();

		namingWindow = new LearnNewObjectFrame("Apprentissage d'un nouvel objet");
		namingWindow.resize(600, 300);

		positionWindow = new PositionFrame("Position de l'avatar");
		positionWindow.resize(350, 150);

		commandWindow = new CommandFrame("Commandes de l'utilisateur");
		commandWindow.resize(600, 270);
		commandWindow.show();

		if (!connectedToServer) {
			infoFrame = new InfoFrame("Pas de serveur!", noServer);
			infoFrame.resize(500, 200);
			infoFrame.visible = true;
			infoFrame.show();
		}

		System.out.println("Init. termine");
		start();
	}

	public void shutdown() {
		stop();
		namingWindow.hide();
		positionWindow.hide();
		commandWindow.hide();
	}

	public void rectifie_vue() {
		demitourpos_changed.setValue(vecteur_null);
		demitourrot_changed.setValue(rotation_null);
		position_changed.setValue(position_actuelle);
		rotation_changed.setValue(rotation_actuelle);
		relie_changed2.setValue(true);  
		relie_changed1.setValue(true);
	}

	public void processEvent (vrml.Event e) {
		if (e.getName().equals("set_fraction")) {
			ConstSFFloat set_fraction;

		}
		// Here is an event activated when the Surveillance Sensor has
		// detected a movement. It updates the coordinates on the 
		// Apprentissage window

		if (e.getName().equals("set_position")) {
			ConstSFVec3f set_position;
			set_position = (ConstSFVec3f)e.getValue();
			position_actuelle = set_position;
			float x, y, z;
			x = set_position.getX();
			y = set_position.getY();
			z = set_position.getZ();
			int xx, yy, zz;
			xx = (int)(x*100f); 
			yy = (int)(y*100f); 
			zz = (int)(z*100f);
			if ((xx != ancien_xx) || (yy != ancien_yy) || (zz != ancien_zz)) {
				positionWindow.posx.setText(Float.toString((float)xx/100f));
				positionWindow.posy.setText(Float.toString((float)yy/100f));
				positionWindow.posz.setText(Float.toString((float)zz/100f));

				ancien_xx = xx; 
				ancien_yy = yy; 
				ancien_zz = zz;
			}
			// rectifie_vue();
		}

		// Here is an event activated when the Surveillance Sensor has
		// detected a movement. It updates the rotation axis on the 
		// Apprentissage namingWindow.
		// When the program is set off, we have only the viewpoint
		// orientation 0 0 0 1 0
		if (e.getName().equals("set_rotation")) {
			ConstSFRotation set_rotation;
			float[] r = new float[4];
			int[] rr = new int[4];

			set_rotation = (ConstSFRotation) e.getValue();
			rotation_actuelle = set_rotation;
			set_rotation.getValue(r);
			rr[0] = (int)(r[0]*100f); 
			rr[1] = (int)(r[1]*100f); 
			rr[2] = (int)(r[2]*100f); 
			rr[3] = (int)(r[3]*100f);
			if ((rr[0] != ancien_rr0) || (rr[1] != ancien_rr1)
				|| (rr[2] != ancien_rr2) || (rr[3] != ancien_rr3)) {
				positionWindow.axex.setText(Float.toString((float)rr[0]/100f));
				positionWindow.axey.setText(Float.toString((float)rr[1]/100f));
				positionWindow.axez.setText(Float.toString((float)rr[2]/100f));
				positionWindow.angle.setText(Float.toString((float)rr[3]/100f));
				ancien_rr0 = rr[0]; 
				ancien_rr1 = rr[1]; 
				ancien_rr2 = rr[2]; 
				ancien_rr3 = rr[3];
				// We must take care that the rotation is
				// inited with the avatar viewpoint and not
				// with a rotation axis
				if ((orientationInited) && (firstRotation))
					firstRotation = false;
			}
			if (!orientationInited)
				orientationInited = true;
			// rectifie_vue();
		}
		if (e.getName().equals("demi_rotation")) {
			ConstSFRotation demi_rotation;
			demi_rotation = (ConstSFRotation)e.getValue();
			float[] r = new float[4];
			demi_rotation.getValue(r);
			//affiche("-----------------> DEMI-ROTATION   :::: " + r[0] + " " + r[1] + " " + r[2] + " " + r[3]);
			rotation_actuelle.getValue(r);
			//affiche("-----------------> ROTATION-ACTUELLE :::: " + r[0] + " " + r[1] + " " + r[2] + " " + r[3]);
		}

		if (e.getName().equals("fraction")) {
			affiche("Fraction--------------->" + instant);
			if (moving) {
				instant += 0.02;
				if ((instant >= 0.0F) && (instant < 1.0F)) {
					instant_changed.setValue(instant);

				}
				if (instant >= 1.0F) {
					instant_changed.setValue(1.0F);
					instant = 0.0f;
					moving = false;
					//	rectifie_vue();
					timer.setValue(false);
				}
			}
		}
	}

	// This method parses the string and sets coordinates
	// into array tf[]
	// Coordinates corresponds to
	// t x y z 		(a translation)
	// r x y z theta	(a rotation)
	// c x y z xr yr zr theta (a translation and a rotation)

	public char parseCoordinateString(String coords, float tf[]) throws Exception {
		affiche("Analyse des coordonnes " + coords);
		System.out.println("Parsing Coordinates: " + coords);
		char ordre;
		int k;

		ordre = coords.charAt(0);
		coords = coords.substring(2, coords.length());
		
		StringTokenizer st = new StringTokenizer(coords);

		switch (ordre) {
			case 't':
				for (k = 0; k < 3; k++)
					tf[k] = (new Float(st.nextToken())).floatValue();
				break;
			case 'r':
				for (k = 0; k < 4; k++)
					tf[k] = (new Float(st.nextToken())).floatValue();
				break;
			case 'c':
				for (k = 0; k < 7; k++)
					tf[k] = (new Float(st.nextToken())).floatValue();
				break;
			default:
				return 'e'; // An error is returned
		}
		return ordre;
	}

	public void affiche(String st) {
		if (commandWindow.bavard.getState())
			System.out.println(st);
	}

}

