% Fichier action.pl
% La dfinition des actions

%*******************************************************************
%			ORDRES
%*******************************************************************

mouvement(c, [X, Y, Z], Angle) :- % Ne sert  rien pour l'instant. Correspond  une translation et une rotation combines
	%write('&1c '),
	write(X), write(' '),
	write(Y), write(' '),
	write(Z), write(' '),
	write(Angle),nl.

mouvement(t, [X, Y, Z]) :-	% mouvement une translation
	write('&1t '),
	write(X), write(' '),
	write(Y), write(' '),
	write(Z), nl.

mouvement(r, Angle) :-	% une rotation
	write('&1r 0 1 0 '),
	write(Angle), nl.

arrete_mouvement :-
	write('&1s'), nl.

%*******************************************************************
%			ACTIONS
%*******************************************************************

% Ordres simples
% tourner(+PositionInitiale, -LMouvements)

tourner(moi([X0, Y0, Z0, Angle0]), [[c, X0, Y0, Z0, Angle1], [r, Angle1]]) :-
        ou(a_gauche, [X0, Y0, Z0, Angle0], pi/2, Angle1). % Par defaut, dans le sens direct

monter(moi([X0, Y0, Z0, Angle0]), [[c, X0, Y1, Z0, Angle0], [t, X0, Y1, Z0]]) :-
	Y1 is Y0 + 1.

descendre(moi([X0, Y0, Z0, Angle0]), [[c, X0, Y1, Z0, Angle0], [t, X0, Y1, Z0]]) :-
	Y1 is Y0 - 1.

avancer(moi([X0, Y0, Z0, Angle0]), [[c, X1, Y0, Z1, Angle0], [t, X1, Y0, Z1]]) :-
        avance_position([X0, Y0, Z0, Angle0], 7, [X1, Y0, Z1]).

reculer(moi([X0, Y0, Z0, Angle0]), [[c, X1, Y0, Z1, Angle0], [t, X1, Y0, Z1]]) :-
        avance_position([X0, Y0, Z0, Angle0], -7, [X1, Y0, Z1]).

% fonction sauter sur place. Pourrait tre redfini en : on monte et on descend
sauter(moi([X0, Y0, Z0, Angle0]), [[c, X0, Y1, Z0, Angle0], [t, X0, Y1, Z0], [c, X0, Y0, Z0, Angle0], [t, X0, Y0, Z0]]) :-
	Y1 is Y0 + 1.

% Direction simple : tourner  gauche, par ex.
% tourner(+PositionInitiale, +Direction, -LMouvements)
% Pour l'instant, le type de partie du discours est constant et vaut adv.

tourner(moi([X0, Y0, Z0, Angle0]), [Adv | _], [[c, X0, Y0, Z0, Angle1], [r, Angle1]]):-
	adv(Adv, _),
	ou(Adv, [X0, Y0, Z0, Angle0], pi/8, Angle1).

% fonction regarder quelque chose. On tourne la tte et on revient.
% regarder(+PositionInitiale, +Direction, -LMouvements)

regarder(moi([X0, Y0, Z0, Angle0]), [Adv | _], LMouvements):-
	tourner(moi([X0, Y0, Z0, Angle0]), [Adv | _], LMouvements1),
	append(LMouvements1, [[c, X0, Y0, Z0, Angle0], [r, Angle0]], LMouvements).

% action "sauter  droite" ou "sauter  gauche"
% ---------------------------------------------------

sauter(moi([X0, Y0, Z0, Angle0]), [Adv | _], LMouvements) :-
	adv(Adv, _),
	ou(Adv, [X0, Y0, Z0, Angle0], pi/2, Angle1),
        Mouvement = [[c, X0, Y0, Z0, Angle1], [r, Angle1]],
        avance_position([X0, Y0, Z0, Angle1], 7, [X1, Y0, Z1]),
	presence_objet([X0, Y0, Z0], [X1, Y0, Z1], Presence, Objet),
        ((Presence =:= 1, write('Objet prsent sur la trajectoire : '), write(Objet), nl)
        ;
        true),
	realisation_parabole([X0, Y0, Z0], Angle1, [X1, Y0, Z1], Presence, Objet, MouvementsSuite),
        append(Mouvement, MouvementsSuite, LMouvements).


% Direction complexe avec rcupration du lieu
% aller(+PositionInitiale, +GroupePrep, +Objet, -LMouvements)


aller(moi([X0, Y0, Z0, Angle0]), [Prep | _], Objet, LMouvements) :-
	prep(Prep, Preposition),
	!,
	destination(Preposition, Objet, [X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurPVFinal),
	vecteur_directeur([X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurTranslation),
	angles(Angle0, VecteurTranslation, AnglePourTranslation),
	angles(AnglePourTranslation, VecteurPVFinal, AnglePourObservation),
        LMouvements = [[c, XFinal, YFinal, ZFinal, AnglePourObservation], [r, AnglePourTranslation], [t, XFinal, YFinal, ZFinal], [r, AnglePourObservation]]. % le c ne sert  rien.

% Pour tourner, on ne considre que la prposition vers.
% L'analyse est ici la mme que pour aller. Ce qui est bien sr imparfait
% et  corriger plus tard.
tourner(moi([X0, Y0, Z0, Angle0]), [Prep | _], Objet, [[r, AnglePourObservation]]) :-
	prep(Prep, vers),
	!,
	destination(vers, Objet, [X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurPVFinal),
	vecteur_directeur([X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurTranslation),
	angles(Angle0, VecteurTranslation, AnglePourTranslation),
	angles(AnglePourTranslation, VecteurPVFinal, AnglePourObservation).

% Pour regarder, c'est quivalent  tourner vers.
regarder(moi([X0, Y0, Z0, Angle0]), _, Objet, [[r, AnglePourObservation]]) :-
	destination(vers, Objet, [X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurPVFinal),
	vecteur_directeur([X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurTranslation),
	angles(Angle0, VecteurTranslation, AnglePourTranslation),
	angles(AnglePourTranslation, VecteurPVFinal, AnglePourObservation).


% action "sauter par_dessus"
% ===========================

sauter(moi([X0, Y0, Z0, Angle0]), [Prep | _], Objet, LMouvements) :-
	prep(Prep, Preposition),
	!,
        Objet = objet([_, _, X, Y, Z | Reste]),
	destination(Preposition, Objet, [X0, Y0, Z0], [XFinal, YFinal, ZFinal], _),
	vecteur_directeur([X0, Y0, Z0], [XFinal, YFinal, ZFinal], VecteurTranslation),
	angles(Angle0, VecteurTranslation, AnglePourTranslation),
        LMouvements1 = [[c, X0, Y0, Z0, AnglePourTranslation], [r, AnglePourTranslation]],
	calcul_vitesse([X0, Y0, Z0], AnglePourTranslation, [X, Y, Z | Reste], Vitw, Vity, Vwo, H),
	parabole(1, [X0, Y0, Z0], AnglePourTranslation, [X, Y, Z], Vitw, Vity, Vwo, H, [], LMouvementsSuite),
        append(LMouvements1, LMouvementsSuite, LMouvements).



% Dtermination de la prsence d'un objet sur la trajectoire parabolique dans le cas d'un saut 
% et et calcul des points d'intersection
% reponse_presence(+Discriminant, +PositionObjet, +Position0, +Position1, +A, +B, -Rep)
%----------------------------------
%

reponse_presence(Discriminant, _, _, _, _, _, 0) :-
	Discriminant < 0.
reponse_presence(Discriminant, PositionObjet, Position0, Position1, A, B, Rep):-
	Discriminant >= 0,
	points_intersection(PositionObjet, A, B, Discriminant, Intersection1, Intersection2),
	intersection(Intersection1, Position0, Position1, R1),
	!,
	intersection(Intersection2, Position0, Position1, R2),
	!,
	traite_rep(R1, R2, Rep).

% On verifie si Objet se trouve entre Position0 et Position1
%--------------------------------
% On rend 0 ou 1
% pre_un_obj(+Objet, +Position0, +Position1, -Reponse)

pre_un_objet(objet([_, _, X, _, Z, _, _, _, Taille, _]), Position0, Position1, Rep) :-
	PositionObjet = [X, _, Z],
	calcul_a_b(Position0, Position1, A, B),
	discriminant(PositionObjet, Taille, A, B, Delta),
	reponse_presence(Delta, PositionObjet, Position0, Position1, A, B, Rep).

% fonction effectuant la boucle de prsence pour tous les objets
%-------------------------------------------------------------------
% On s'arrte au premier objet trouv
%boucle_objet(+LObjets, +Position0, +Position1, +PresenceObjetCourant, -PresenceFinale, ObjetCourant, -ObjetPresent)

boucle_objets([], _, _, 0, 0, ObjetPresent, ObjetPresent) :- !. % On a atteint le dernier objet et il n'est pas prsent
boucle_objets(_, _, _, 1, 1, ObjetPresent, ObjetPresent) :- !.
boucle_objets([Objet | LObjets], Position0, Position1, 0, PresenceFinale, _, Obj) :-
	pre_un_objet(Objet, Position0, Position1, PresenceObjet),
	boucle_objets(LObjets, Position0, Position1, PresenceObjet, PresenceFinale, Objet, Obj).


% faire une fonction qui detecte la presence d'objets sur le parcours eventuel de la camera
% entre Position0 et Position1
% presence_objet(+Position0, +Position1, -Presence, -ObjetPresent)
%-------------------------------------------------------------------------------------------
presence_objet(Position0, Position1, Presence, ObjetPresent) :-
	monde(LObjets),
	!,
	boucle_objets(LObjets, Position0, Position1, 0, Presence, _, ObjetPresent).

% fonction calculant les vitesses quand il n'y pas d'objets
% ---------------------------------------------------------
% calcul_vitesse_sans_objet(+PositionInitiale, +PositionFinale, -VitesseHorizontale, -VitesseVerticale, -DistanceHorizontale, )

calcul_vitesse_sans_objet([X0, Y0, Z0], [X1, _, Z1], Vitw, Vity, Vwo, 1.5) :-
	Vity is (50 - Y0)/10,
	Vwo is ((X1 - X0)*(X1 - X0) + (Z1 - Z0)*(Z1 - Z0)),
	W is sqrt(Vwo),
	Vitw is W/10.


% fonction qui calcule les vitesses relatives au mouvement de la camera
% ---------------------------------------------------------------------
% calcul_vitesse(+PositionInitiale, +Angle, +CaractristiquesObjet, -VitesseHorizontale, -VitesseVerticale, -DistanceHorizontale, -Hauteur)

calcul_vitesse([X0, Y0, Z0], _, [X, _, Z, _, _, _, Taille, _], Vitw, Vity, Vwo, H) :-
	H is Taille + 2*Taille/3,
	Vity is (50 - Y0)/10,
	Vwo is (X - X0)*(X - X0) + (Z - Z0)*(Z - Z0),
	W is sqrt(Vwo) + Taille,
	Vitw is W/10.


% fonction effectuant le calcul de parabole et l'execution du mouvement
% ---------------------------------------------------------------------
% parabole(+Indice, +PositionInitiale, +AngleFinal, +PositionFinale, +VitesseHorizontale, +VitesseVerticale, +DistanceHorizontale, +Hauteur, LMouvements, LMouvementsF)
parabole(11, _, _, _, _, _, _, _, LMouvements, LMouvements) :- !.
parabole(Indice, [X0, Y0, Z0], Angle, [X1, Y1, Z1], Vitw, Vity, Vwo, H, LMouvements, LMouvementsF):-
	Y is Vity*Indice - (Indice*Indice)/2, 
	W is Vitw*Indice,
	catch(Coeff is W/sqrt(Vwo), _, Coeff is 1),
	X is Coeff*(X1 - X0),
	Z is Coeff*(Z1 - Z0),
	Yfin is (Y + Y0)*H/12.5 + Y0, % Modification du code de Frdric Hubert
	Xfin is X + X0,
	Zfin is Z + Z0,
        append(LMouvements, [[c, Xfin, Yfin, Zfin, Angle], [t, Xfin, Yfin, Zfin]], LMouvements1),
	NIndice is Indice + 1,
	parabole(NIndice, [X0, Y0, Z0], Angle, [X1, Y1, Z1], Vitw, Vity, Vwo, H, LMouvements1, LMouvementsF).

% fonction ralisant une parabole en fonction des rponses obtenues
%-------------------------------------------------------------------------
% realisation_parabole(+Position0, +Angle1, +Position1, +PresenceObjet, +Objet, -LMouvements)

realisation_parabole(Position0, Angle1, Position1, 0, _, LMouvements) :-
	calcul_vitesse_sans_objet(Position0, Position1, Vitw, Vity, Vwo, H),
	parabole(1, Position0, Angle1, Position1, Vitw, Vity, Vwo, H, [], LMouvements).
realisation_parabole(Position0, Angle1, _, 1, objet([_, _, X, Y, Z | Reste]), LMouvements) :- 
	calcul_vitesse(Position0, Angle1, [X, Y, Z | Reste], Vitw, Vity, Vwo, H),
	parabole(1, Position0, Angle1, [X, Y, Z], Vitw, Vity, Vwo, H, [], LMouvements).
