%***********************************************************
%		Le programme :
%
% Rcuprer le groupe verbal vg qui nous donne le verbe et donc l'action  faire.
% Ensuite, prendre le complment pg qui nous dit o...
% En dduire une position ( partir d'une liste de donnes)
% Envoyer a au commutateur de message qui transmettra...
%

% moteur_linguistique(+PositionInitiale, +Ordre, -Sortie)
% On passe au moteur linguistique
% la position de l'avatar, l'ordre et il retourne la sortie sous la forme
% d'ordres de dplacement et de rotation. Pour l'instant les ordres sont passs
% par criture directe dans un fichier et Sortie est une liste vide
% Il aurait t prfrable de faire le dcoupage ici : tokens(OrdreMots, OrdreCars, []),


moteur_linguistique(PositionInitiale, OrdreCars, []) :-
	tokens(OrdreMots, OrdreCars, []),
	analyse_syntaxique(OrdreMots, FormeSynt),	% pour la phrase : va vers la voiture
					% X = [vg([aller]), pg([vers, la, voiture])]
	resolution_reference(PositionInitiale, FormeSynt, Objet),
	arrete_mouvement,
	determine_mouvements(PositionInitiale, FormeSynt, Objet, LMouvements),
        transmets_mouvements(LMouvements),
	!. 
moteur_linguistique(_, _, _) :-
	write('&1e'), nl.	% Erreur dans l'analyse. On repart sur boucle d'entre

% Dtermination et ralisation de l'ordre : determine_mouvements/4
% determine_mouvements(+PositionInitiale, +FormeSynt, +Objet, -LMouvements),

% un verbe tout seul : monte
determine_mouvements(PositionInitiale, [vg([Verbe])], [], LMouvements) :-
	!,
	write(Verbe), nl,
	Mouvement =.. [Verbe, PositionInitiale, LMouvements],
        Mouvement.

% un verbe et un adverbe : tourne  droite (a_droite)
determine_mouvements(PositionInitiale, [vg([Verbe]), rg(Adv)], [], LMouvements) :-
	!,
	Ordre =.. [Verbe, PositionInitiale, Adv, LMouvements],
	write(Ordre), nl,
	Ordre.

% un verbe et un groupe prpositionnel : va vers la voiture
determine_mouvements(PositionInitiale, [vg([Verbe]), pg(GroupePrep)], Objet, LMouvements):-
	% Ordre = aller([vers, la voiture])
	!,
	Ordre =.. [Verbe, PositionInitiale, GroupePrep, Objet, LMouvements],
	write(Ordre), nl,
	Ordre.

% un verbe et un groupe nominal : regarde la voiture
determine_mouvements(PositionInitiale, [vg([Verbe]), ng(GroupeNom)], Objet, LMouvements):-
	% Ordre = regarde([la voiture])
	!,
	Ordre =.. [Verbe, PositionInitiale, GroupeNom, Objet, LMouvements],
	write(Ordre), nl,
	Ordre.


% nombre_objets(-N) retourne le nombre d'objet du monde
nombre_objets(N) :-
	monde(X),
	length(X, N).


transmets_mouvements([]).
transmets_mouvements([[c, X, Y, Z, A] | Mouvements]) :-
        mouvement(c, [X, Y, Z], A),
        transmets_mouvements(Mouvements).
transmets_mouvements([[t, X, Y, Z] | Mouvements]) :-
        mouvement(t, [X, Y, Z]),
        transmets_mouvements(Mouvements).
transmets_mouvements([[r, A] | Mouvements]) :-
        mouvement(r, A),
        transmets_mouvements(Mouvements).