/*
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Strips/3...
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

strips(InitState, GoalList, Plan):-
	strips1(InitState, GoalList,[],[],_,RevPlan),
	reverse(RevPlan,Plan).

% Arguments pour Strips1 :
% current state, goal list, current plan, operators forbidden in
% current stage of planning, new state, new plan.
strips1(State,GoalList,Plan,_,State,Plan):-
	subset(GoalList,State).
strips1(State,GoalList,Plan,ForbiddenActions,NewState,NewPlan):-
	member(Goal,GoalList),
	not(member(Goal,State)),
	adds(Ac,Goal),
	not(member(Ac,ForbiddenActions)),
	preclist(Ac,PrecList),
	strips1(State,PrecList,Plan,[Ac|ForbiddenActions],TmpState1,TmpPlan1),
	apply_rule(Ac,TmpState1,TmpState2),
	strips1(TmpState2,GoalList,[Ac|TmpPlan1],ForbiddenActions,NewState,NewPlan).

% Arguments pour apply_rule
% operatot, current state, next state
apply_rule(Ac,State,NewState):-
	nl,write('doing'),write(Ac),ttyflush,
	dellist(Ac,DelList),
	substract(State,DelList,TmpState),
	addlist(Ac,AddList),
	union(AddList,TmpState,NewState).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The blocks world
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

strips-rule(stack(X,Y),
	[clear(Y),holding(X)],
	[on(X,Y),clear(X),handempty],
	[clear(Y),holding(X)]).

strips-rule(unstack(X,Y),
	[on(X,Y),clear(X),handempty],
	[clear(Y),holding(X)],
	[on(X,Y),clear(X),handempty]).

strips-rule(pickup(X),
	[ontable(X),clear(X),handempty],
	[clear(Y),holding(X)],
	[on(X,Y),clear(X),handempty]).

strips-rule(putdown(X),
	[holding(X)],
	[ontable(X),clear(X),handempty],
	[holding(X)]).


aa:-
	strips([clear(a),clear(b),clear(c),ontable(a),ontable(b),ontable(c),handempty],
	[on(b,c),on(a,b)],
	Plan).

bb:-
	strips([clear(c),ontable(a),on(b,a),on(c,b),handempty],
	[on(a,b),on(b,c)],
	Plan).
*/
