:- [references, action, cle, monde, param, analyse, util, dico].
:- dynamic(moi/1).
:- dynamic(monde/1).
:- dynamic(error/0).



moi([0, 0, 0, 0]).
%e:-d([0,1,0,0]).

a :- resolution_reference([la, boule],[la, boule, rouge], A).
b :- resolution_reference([boule],[la, boule, vert], A).
c :- resolution_reference([la, boule],[devant, la, boule], A).

va1 :- aller([devant, la, boule]).
va2 :- aller([derrire, la, boule]).
va3 :- aller([devant, la, voiture]).
va4 :- aller([derrire, la, voiture]).
va5 :- aller([_droite_de, la, voiture, bleue, , pois, jaune]).
va6 :- aller([derrire, la, boule, verte]).
va7 :- aller([devant, l, ordinateur]).
va8 :- aller([vers, l, ordinateur]).
va9 :- aller([vers, la, voiture]).

boucle_entree :-
	ulysse_folder(UlysseFolder), %=c:/mesdoc~1/ulysse/
	prolog_input_position_file(InPro1),
	prolog_input_command_file(InPro2),
	concatenate(UlysseFolder, InPro1, PathInPro1),
	concatenate(UlysseFolder, InPro2, PathInPro2),
	repeat,
	once(
		(
%		fileerrors(_, off), % Pour viter le dbugger si le fichier n'existe pas, remplac par catch/3
%		write(PathInPro1), nl,
		catch(see(PathInPro1), Erreur1, fail),
		%see('c:/mesdoc~1/ulysse/temp/InPro1'),
		catch(read(Clause), Erreur2, fail),
		seen,
		write(Clause), nl, %write('\nl'),
		Clause,
		told)
	),
	(delete_file(PathInPro1) ; true),
	(delete_file(PathInPro2) ; true),
	%(delete_file('c:/mesdoc~1/ulysse/temp/InPro1') ; true),
	%(delete_file('c:/mesdoc~1/ulysse/temp/InPro2') ; true),
	fail.

boucle :-
	init_parameters,
	ulysse_folder(UlysseFolder), %=c:/mesdoc~1/ulysse/
	prolog_input_position_file(InPro1),
	prolog_input_command_file(InPro2),
	concatenate(UlysseFolder, InPro1, PathInPro1),
	concatenate(UlysseFolder, InPro2, PathInPro2),
	repeat,
	once(
		(write('La clause indiquant la position, par ex: d([0, 0, 0, 0])'), nl,
		catch(read(Clause), Erreur2, fail),
		write(Clause), nl, %write('\nl'),
		Clause)
	),
	fail.

% Analyse de la phrase : d/1
d(Lieu) :-
	retract(moi(C)),
	L =.. [moi, Lieu],
	asserta(L),
	once((
		ulysse_folder(UlysseFolder), %=c:/mesdoc~1/ulysse/
		prolog_input_command_file(InPro2),
		prolog_output_file(OutPro),
		concatenate(UlysseFolder, InPro2, PathInPro2),
		concatenate(UlysseFolder, OutPro, PathOutPro))),
	analyse(X),		% pour la phrase : va vers la voiture
				% X = [vg([aller]), pg([vers, la, voiture])]
	%tell('c:/mesdoc~1/ulysse/temp/OutPro'),
	arrete_mouvement,
	debut(X).
d(X) :- write('&1e'), nl.

% Dtermination de l'ordre : debut/1
debut([X | Syntaxe]):-		% un verbe et un adverbe : tourne  droite (a_droite)
	write(Syntaxe), nl,
	X =.. [vg, [Y]],
	Syntaxe = [Syn],
	Syn =.. [rg, Z],
	!,
	Ordre =.. [Y, Z, adv],
	write(Ordre), nl,
	Ordre.
debut([X | Syntaxe]):-		% un verbe et un groupe prpositionnel : va vers la voiture
	write(Syntaxe), nl,	% Ordre = aller([vers, la voiture])
	X=.. [vg, [Y]],
	Syntaxe = [Syn],
	Syn =.. [pg, Z],!,
	Ordre =.. [Y, Z],
	write(Ordre), nl,
	Ordre.
debut([X]):-			% un verbe tout seul : monte
	X =.. [vg, [Y]],
	!,
	Y.


nombre_objets :-
	monde(X),
	length(X, N),
	ulysse_folder(UlysseFolder), %=c:/mesdoc~1/ulysse/
	prolog_output_file(OutPro),
	concatenate(UlysseFolder, OutPro, PathOutPro),
	tell(PathOutPro),
	write('#'), write(N),
	told.

